﻿using UnityEngine;
using System.Collections;

public class Player : MonoBehaviour {

	public float vX;
	public float vY;
	public float auxY = 15;
	Vector2 IniP;
	public float toleranciaX = 5;
	bool seguir = false;
	public PhysicsMaterial2D Rebota;

	public bool onda = false;

	public float longitud = 35;
	public float amplitud = 30;

	bool aux = false;

	int angulo = 0;

	public GameObject Pl;

	public	GameObject Exp;

	bool Dir = false;
	bool BOnda = false;

	// Use this for initialization
	void Start () {
	
		IniP = GameObject.Find("Ini Player").GetComponent<Transform>().position;

	}
	
	// Update is called once per frame
	void Update () {


		if (Mathf.Abs(IniP.x - transform.position.x) > toleranciaX)
			seguir = true;

		if (Mathf.Abs(IniP.x - transform.position.x) <= 0.2f)
			seguir = false;

		if(seguir == true)
			transform.position = Vector3.Lerp (transform.position, IniP, 0.1f);




		if ((Input.GetKey (KeyCode.Space)|| BOnda == true) && GameObject.Find("Administrador").GetComponent<Administrador>().Energia > 0) {
			onda = true;
		} else {
			onda = false;
			BOnda = false;
		}
			

		if (Input.GetKey (KeyCode.W) || Dir == true) {
			vY = auxY;
		} else if (Input.GetKey (KeyCode.S) || Dir == false) {
			vY = -auxY;
		} else {
			vY = 0;
		}



		if (onda != aux) {
			gameObject.GetComponent<Rigidbody2D> ().velocity = new Vector2 (0, 0);
			aux = onda;
		}

		if (onda) {
			
			transform.localScale = new Vector2 (0.4f, 0.4f);

			gameObject.GetComponent<CircleCollider2D> ().sharedMaterial = Rebota;

			gameObject.GetComponent<Instanciador> ().enabled = true;

			if (angulo < 359)
				angulo++;
			else
				angulo = 0;

			gameObject.GetComponent<Rigidbody2D> ().velocity = new Vector2 
				(vX, (Mathf.Sin(angulo*longitud*0.0174533f))*amplitud);

			if(GameObject.Find("Administrador").GetComponent<Administrador>().Energia > 0)

			GameObject.Find("Administrador").GetComponent<Administrador>().Energia-= 0.5f;


		} else {

			transform.localScale = new Vector2 (1f, 1f);

			gameObject.GetComponent<CircleCollider2D> ().sharedMaterial = null;

			gameObject.GetComponent<Instanciador> ().enabled = false;

			gameObject.GetComponent<Rigidbody2D> ().velocity = new Vector2 (vX , 

			vY);

			angulo = 0;

			if(GameObject.Find("Administrador").GetComponent<Administrador>().Energia < 100)
			GameObject.Find("Administrador").GetComponent<Administrador>().Energia += 0.25f;

		}

		if(GameObject.Find("Administrador").GetComponent<Administrador>().duplicados == false)
			GetComponent<SpriteRenderer>().color = Color.white;
	}

	void OnCollisionEnter2D(Collision2D c)
	{
		if ((c.gameObject.tag == "Placa" || c.gameObject.tag == "Placa de Metal") && onda == false) {

			GameObject boom = Instantiate(Exp);

			boom.transform.position = transform.position;



			Destroy (boom.gameObject, 1);

			Destroy (this.gameObject);
	  }

		if (c.gameObject.tag == "Antiparticula" && onda == false) {

			GameObject boom = Instantiate(Exp);

			boom.transform.position = transform.position;



			Destroy (boom.gameObject, 1);

			Destroy (c.gameObject);

			Destroy (this.gameObject);
		}
	}

void OnTriggerEnter2D(Collider2D c)
	{
		
		if (c.tag == "Lente" && GameObject.Find ("Administrador").GetComponent<Administrador> ().duplicados == false && onda == true) {

			GameObject.Find ("Administrador").GetComponent<Administrador> ().duplicados = true;

			GameObject Rojo = Instantiate (Pl);
			Rojo.transform.position = transform.position;
			Rojo.GetComponent<Player> ().auxY = 2f;
			Rojo.GetComponent<Player> ().longitud = 16f;
			Rojo.GetComponent<Player> ().BOnda = true;
			Rojo.GetComponent<SpriteRenderer> ().color = Color.red;

			GameObject Naranja = Instantiate (Pl);
			Naranja.transform.position = transform.position;
			Naranja.GetComponent<Player> ().auxY = 3f;
			Naranja.GetComponent<Player> ().longitud = 20f;
			Naranja.GetComponent<SpriteRenderer> ().color = new Vector4 (0.9f, 0.3f, 0, 1);
			Naranja.GetComponent<Player> ().BOnda = true;

			GameObject Amarillo = Instantiate (Pl);
			Amarillo.transform.position = transform.position;
			Amarillo.GetComponent<Player> ().auxY = 4f;
			Amarillo.GetComponent<Player> ().longitud = 24f;
			Amarillo.GetComponent<SpriteRenderer> ().color = Color.yellow;
			Amarillo.GetComponent<Player> ().BOnda = true;

			GameObject Verde = Instantiate (Pl);
			Verde.transform.position = transform.position;
			Verde.GetComponent<Player> ().auxY = 5f;
			Verde.GetComponent<Player> ().longitud = 28f;
			Verde.GetComponent<SpriteRenderer> ().color = Color.green;
			Verde.GetComponent<Player> ().BOnda = true;

			GameObject Cyan = Instantiate (Pl);
			Cyan.transform.position = transform.position;
			Cyan.GetComponent<Player> ().auxY = 6f;
			Cyan.GetComponent<Player> ().longitud = 32f;
			Cyan.GetComponent<SpriteRenderer> ().color = Color.cyan;
			Cyan.GetComponent<Player> ().BOnda = true;


			GetComponent<SpriteRenderer> ().color = Color.blue;

			GameObject Violeta = Instantiate (Pl);
			Violeta.transform.position = transform.position;
			Violeta.GetComponent<Player> ().auxY = 8f;
			Violeta.GetComponent<Player> ().longitud = 40f;
			Violeta.GetComponent<SpriteRenderer> ().color = Color.magenta;
			Violeta.GetComponent<Player> ().BOnda = true;


		} else if (c.tag == "Lente"  && onda == false){
			GameObject boom = Instantiate(Exp);

			boom.transform.position = transform.position;



			Destroy (boom.gameObject, 1);

			Destroy (this.gameObject);
		}
		
	}

	public void Direcion ()
	{
		Dir = !Dir;

	}
		


	public void Onda ()
	{
		BOnda = !BOnda;

	}

		
}
